
help.start()

help("cos")  # poziv pomoci o funkciji cos

# ili alternativno koristenjem ?:

? exp

help("[[")

####

help.search("cos") # pretrazuje help u potrazi za stringom cos

# ili alternativno

?? cos

####

example(cos)     # primjeri funksije cos, ako postoje u helpu

example(plot)

####

data()   # daje listu svih podataka u primjerima koji se 
         # nalaze u trenutno ucitanim paketima (packages)

#########

getwd()  # trenutni radni direktorij

ls()   # uspis objekata trenutno u radnom prostoru (memoriji)

x<-1
x
ls()
rm("x")  # brisanje objeta (ili skupa objekata)
ls()

options()   # opcije i njihove trenutno postavljene vrijednosti


#################################################
#################################################


# VARIJABLE

# R nudi razlicite operatore za pridruzbu izraza varijablama. 
# Najpoznatiji operator pridruzbe je '<-' (pise se sa dva znaka: '-' i '<')
# i njegova simetricna inacica '-> ' koja se koristi kad lijevu 
# stranu izraza pridruzujemo desnoj.
# To znaci da je :

x <- 1

# isto kao i

1 -> x

# Umjesto ovih tradicijskih R-znakova, 
# moze se koristiti i operator ' =' koji je 
# uobicajen u drugim programskim jezicima. 
# Razlika je jedino u tomu sto operator '=' ima lokalni doseg, 
# a znakovi '<'- i '->' globalni, sto se vidi u primjeru:

mean(x = 1:10)

## [1] 5.5

x

mean(x <- 1:10)

## [1] 5.5

x

##  [1]  1  2  3  4  5  6  7  8  9 10


######################################################
######################################################

# STRUKTURE PODATAKA

# Postoji vise struktura podataka u R-u, a one zajedno s algoritmom 
# (upotrebom programskog grananja, petlji i funkcija) daju program. 
# Program izvrsava zamisljeni algoritam nad programskom strukturom. 
# Svaki podatak ili element strukture ima svoj tip (klasu ili razred), 
# koji moze biti numericki (cijeli brojevi i realni, s pomicnim zarezom), 
# znakovni (za tekst) i logicki (istina ili laz). 
# Tipovi podataka mogu se provjeriti s funkcijom class():

class(3.47)

## [1] "numeric"

class("r programiranje")

## [1] "character"

class(FALSE)

## [1] "logical"

class(100)

## [1] "numeric"

###################################################
###################################################

# VEKTORI

# Vektori su jednodimenzionalna polja koja sadrze istovrsni tip podataka. 

b<-c(1,2,3,4)       # kreira vektor b
b

b1<-c(b,0,b)
b1

# Osim sa c() funkcijom vektori se mogu graditi na jos neke nacine. 
# Evo primjera:

1:5

## [1] 1 2 3 4 5

#ili

seq(0, 200, by = 4)  #sekvenca ili niz brojeva od 0 do 200 s korakom 4

##  [1]   0   4   8  12  16  20  24  28  32  36  40  44  48  52  56  60  64
## [18]  68  72  76  80  84  88  92  96 100 104 108 112 116 120 124 128 132
## [35] 136 140 144 148 152 156 160 164 168 172 176 180 184 188 192 196 200

# Duljina vektora dobije se pozivom length() funkcije, 
# kojoj se kao argument navede ime vekotra:

vek <- seq(0, 200, by = 4)
length(vek)

## [1] 51

# Dohvacanje ili indeksiranje vektora postize se uporabom uglastih 
# zagrada unutar kojih se pise indeks vektora:

vek[15]  ## 15-ti element vektora vek

## [1] 56

# Moguce je indeksirati i vise elemenata vektora, 
# tako da se napise raspon vrijednosti, odnosno kao indeksi vektora 
# uzme vektor indeksa:

vek[10:15]  ## od 10-tog do 15-tog elementa vektora vek

## [1] 36 40 44 48 52 56

vek[c(10, 15, 20, 25)]  ## od 10-ti,15-ti,20-ti, 25-ti element vektora vek

## [1] 36 56 76 96

# Indeksacija vektora ili drugih struktura podataka 
# ne sluzi samo za dohvacanje podataka iz strukture, 
# nego i za upis novog podatka na indeksirano mjesto:

vek[10] <- 101  ## spremanje podatka 101 na desetomjesto vekotra vek
vek

##  [1]   0   4   8  12  16  20  24  28  32 101  40  44  48  52  56  60  64
## [18]  68  72  76  80  84  88  92  96 100 104 108 112 116 120 124 128 132
## [35] 136 140 144 148 152 156 160 164 168 172 176 180 184 188 192 196 200

vek[10:15] <- 18:23  ## od 10-tog do 15-tog elementa vektora vek zamijeni s vektorom 18:23
vek

##  [1]   0   4   8  12  16  20  24  28  32  18  19  20  21  22  23  60  64
## [18]  68  72  76  80  84  88  92  96 100 104 108 112 116 120 124 128 132
## [35] 136 140 144 148 152 156 160 164 168 172 176 180 184 188 192 196 200


v<-numeric()   # definiramo v kao numericku strukturu
v[3]<-10       # vrijednost 10 je postavljena kao treci element od v 
v             # R je atumatski "kreirao" i prvi drugi i element sa vrijednostima NA


########################################################
########################################################

# LISTE

# Lista je vektor kojemu su elementi imenovani, 
# pa se tim imenom mogu dohvacati. 
# Ispred imena pritom se treba staviti znak '$'. 
# Za razliku od vektora, liste mogu sadrzavati elemente 
# bilo kakvog tipa podataka:

student <- list(ime = "Marko", godina = 1990, faks = "FSB", polozioTermu = TRUE)

student$faks

## [1] "FSB"

student$ime

## [1] "Marko"

# Oni se mogu na isti nacin koristiti i u programskim grananjima i izrazima:

if (student$polozioTermu == TRUE) print(student$godina)

## [1] 1990

# kao i indeksacijom slicnoj vektorskoj:

student[["faks"]]

## [1] "FSB"

student[["god"]]

## NULL

student[["god", exact = FALSE]]

## [1] 1990

# Primjetite kako je moguce indeksirati liste i 
# bez potpunog navodenja imena elementa (zahvaljujuci 'exact' atributu).

##########################################################
##########################################################

# MATRICE

# Matrice su dvodimenzionalni vektori 
# (pa prema tomu mogu sadrzavati samo podatke istog tipa). 
# Kod inicijalizacije se pune po stupcima (kao u Fortranu),
# a parametrom 'byrow' to se moze promijeniti:

mat1 <- matrix(1:30, nrow = 3, ncol = 10)
mat1

##      [,1] [,2] [,3] [,4] [,5] [,6] [,7] [,8] [,9] [,10]
## [1,]    1    4    7   10   13   16   19   22   25    28
## [2,]    2    5    8   11   14   17   20   23   26    29
## [3,]    3    6    9   12   15   18   21   24   27    30

mat2 <- matrix(1:30, nrow = 3, ncol = 10, byrow = TRUE)
mat2

##      [,1] [,2] [,3] [,4] [,5] [,6] [,7] [,8] [,9] [,10]
## [1,]    1    2    3    4    5    6    7    8    9    10
## [2,]   11   12   13   14   15   16   17   18   19    20
## [3,]   21   22   23   24   25   26   27   28   29    30

# Indeksacija elemenata matrice slicna je onoj vektorskoj, 
# ali treba imati na umu da matrica ima dvije dimenzije, 
# redaka i stupaca. Ispisom samo jedne dimenzije, 
# matrica se promatra kao jednostupcani ili jednoredcani vektor.

mat2[2, 7]  ## drugi redak, sedmi stupac matrice

## [1] 17

mat1[22]  ## 22.-ti element matrice mat1 kao vektora

## [1] 22

mat2[22]  ## 22.-ti element matrice mat2 kao vektora

## [1] 8

# Slicno kao u vektorima i kod matrica je moguca indeksacija 
# nekog podrucja (podmatrice):

mat2[2:3, 2:5]  ## podrucje izmedju drugog do treceg retka i drugog do petog stupca

##      [,1] [,2] [,3] [,4]
## [1,]   12   13   14   15
## [2,]   22   23   24   25

mat2[1, 4:6]  ## dio prvog retka (izmedju 4. i 6. stupca)

## [1] 4 5 6

################ Jos primjera

d<-c(1,4,3,5,2)
d[c(2,4)]             # odabiranje drugog i cetvrtog elementa vektora d4
d[c(2,4,2,4,1)]
d[c(-2,-4)]      # odabire sve elemente vektora d4 osim drugog i cetvrtog elementa
d[c(TRUE,FALSE,FALSE,TRUE,FALSE)]   # odabire prvi i cetvrti element vektors d4
d[d>2]     # odabire sve elemente vektora d4 koji su veci od 2

d>2

######

A<-matrix(1:9,nrow=3,byrow=TRUE)   

A
A[1,2]
A[1,]    # prvi redak matrice A
A[,2]    # drugi stupac matrica A

A[c(1,2),c(1,3)]
c(A[1,1],A[2,3])

####

# Treba spomenuti da se matricama mogu dodavati i imena stupaca,
# odnosno redaka, uz pomoc funckije dimnames(), 
# makar je to elegantnije rijeseno s posebnom (faktorskom) strukturom:

dimnames(mat1) <- list(c("a1", "a2", "a3"), c("c01", "c02", "c03", "c04", "c05", 
    "c06", "c07", "c08", "c09", "c10"))
mat1

##    c01 c02 c03 c04 c05 c06 c07 c08 c09 c10
## a1   1   4   7  10  13  16  19  22  25  28
## a2   2   5   8  11  14  17  20  23  26  29
## a3   3   6   9  12  15  18  21  24  27  30

#############################################
######   Jos o matricama, primjeri   ########


B <- matrix(c(1, 2, 3, 4, 5, 6), nrow=3, ncol=2) 
B

C <- matrix( c(7, 4, 2), nrow=3, ncol=1)
C


### KREIRANJE MATRICA POMOCU FINKCIJA cbind() i rbind() ###

A<-cbind(B, C)   # matrica A dobivena je kombiniranjem stupaca B i C matrice
A

D <- matrix( c(6, 2), nrow=1, ncol=2)
A1 <- rbind(B,D)  # matrica A dobivena je kombiniranjem redova matrica B i D
                  # i to tako da je matrica D "stavljena ispod"" matrice B
A1

####

A<-matrix(c(1, 2, 3, 4, 5, 6, 7, 8, 9),nrow=3,byrow=TRUE)
A

A<-matrix(1:9,nrow=3,byrow=TRUE)   # slaze elemente po redovima
A1<-matrix(1:9,nrow=3)             # slaze elemente po stupcima

# length(A)
length(A)  # broj elemenata 
nrow(A)    # daje broj redaka matrice
ncol(A)    # daje broj stupaca matrice
dim(A)     # dimenzije matrice

B<-matrix(0,4,4)
B

C<-diag(5)      # jedinicna matrica
C

M<-array(1:20,dim=c(4,5))
M


z<-c(1,2,3,4,5,6,7,8,9,10,11,12)
dim(z)<-c(3,4)
z

dim(z)<-c(6,2)
z
t(z)                    # Transponiranje: t()


###########################################################
###########################################################

# FAKTORI

# Vrijednosti mogu biti nominalne, poredane (eng. ordinal) i kontinuirane. 
# Cijeli brojevi su primjer kontinuiranih vrijednosti. 
# Nominalne i poredane sluze za oznacivanje nekih kategorija, 
# s tom razlikom sto nominalne nemaju redoslijeda. 
# Na primjer, dugine boje ili vrste sportova su nominalne vrijednosti, 
# dok su imena mjeseca ili ocjene znanja poredane vrijednosti. 
# Nominalne i poredane vrijenosti u R-u predstavljaju se faktorima. 
# Faktorima se skup vrijenosti dijeli po razinama:

sportovi <- c("kosarka", "rukomet", "nogomet", "vaterpolo", "atletika")
sportovi

## [1] "kosarka"   "rukomet"   "nogomet"   "vaterpolo" "atletika"

factor(sportovi)

## [1] kosarka   rukomet   nogomet   vaterpolo atletika 
## Levels: atletika kosarka nogomet rukomet vaterpolo

ocjene <- c("nedovoljan", "dovoljan", "dobar", "vrlo dobar", "izvrstan")
ocjene

## [1] "nedovoljan" "dovoljan"   "dobar"      "vrlo dobar" "izvrstan"

factor(ocjene)

## [1] nedovoljan dovoljan   dobar      vrlo dobar izvrstan  
## Levels: dobar dovoljan izvrstan nedovoljan vrlo dobar

# Ocevidno je, da se poredak u razinama faktora automatski 
# postavio prema abecednom redoslijedu imena zadanih vrijenosti. 
# Medutim, ako se zeli uvesti redoslijed po poretku upisa (indeksu polja), 
# onda se koristi argument 'order=TRUE':

ocjene <- c("nedovoljan", "dovoljan", "dobar", "vrlo dobar", "izvrstan")
ocjene

## [1] "nedovoljan" "dovoljan"   "dobar"      "vrlo dobar" "izvrstan"

factor(ocjene, order = TRUE, levels = ocjene)

## [1] nedovoljan dovoljan   dobar      vrlo dobar izvrstan  
## Levels: nedovoljan < dovoljan < dobar < vrlo dobar < izvrstan

####################################################################
####################################################################

# OKVIRI PODATAKA

# Najcesce koristena struktura podataka je okvir podataka koji 
# se generira s funkcijom data.frame(). 
# Okvir podatka je lista imenovanih stupaca jednake duljine. 
# Po izgledu podsjeca na tablicu tablicnog kalkulatora ili 
# kompjutorske baze, ali to strukturno nije isto. 
# Dohvacanje podataka iz okvira slicno je dohvacanju elemenata 
# liste, npr. 'ime_okvira[c('ime_stupca1','ime_stupca_n')] 
# ili pojedinacnog sa ime_okvira$ime_stupca_x. 
# Pri tomu je moguce izdvojiti samo one redke okvira koji zadovoljavaju 
# stanoviti kriterij, npr. ime_okvira$ime_stupca_x['ime_stupca_y' > n].

pacijentID <- c(1, 2, 3, 4, 5, 6, 7, 8, 9, 10)
godine <- c(25, 34, 28, 52, 44, 58, 72, 81, 26, 60)
diabetes <- c("Tip1", "Tip2", "Tip1", "Tip1", "Tip2", "Tip2", "Tip1", "Tip2", 
    "Tip2", "Tip2")
status <- c("Slabo", "Poboljsano", "Izvrsno", "Poboljsano", "Izvrsno", "Slabo", 
    "Slabo", "Poboljsano", "Slabo", "Slabo")
pacijent <- data.frame(pacijentID, godine, diabetes, status)
pacijent

##    pacijentID godine diabetes     status
## 1           1     25     Tip1      Slabo
## 2           2     34     Tip2 Poboljsano
## 3           3     28     Tip1    Izvrsno
## 4           4     52     Tip1 Poboljsano
## 5           5     44     Tip2    Izvrsno
## 6           6     58     Tip2      Slabo
## 7           7     72     Tip1      Slabo
## 8           8     81     Tip2 Poboljsano
## 9           9     26     Tip2      Slabo
## 10         10     60     Tip2      Slabo


# Dohvacanje elemenata od okvira podataka
pacijent[1:2]

##    pacijentID godine
## 1           1     25
## 2           2     34
## 3           3     28
## 4           4     52
## 5           5     44
## 6           6     58
## 7           7     72
## 8           8     81
## 9           9     26
## 10         10     60

pacijent[c("diabetes", "status")]

##    diabetes     status
## 1      Tip1      Slabo
## 2      Tip2 Poboljsano
## 3      Tip1    Izvrsno
## 4      Tip1 Poboljsano
## 5      Tip2    Izvrsno
## 6      Tip2      Slabo
## 7      Tip1      Slabo
## 8      Tip2 Poboljsano
## 9      Tip2      Slabo
## 10     Tip2      Slabo

pacijent$godine

##  [1] 25 34 28 52 44 58 72 81 26 60

pacijent$godine[pacijent$status == "Slabo"]

## [1] 25 58 72 26 60

##############################################################
##############################################################

# POLJA (ARRAY)

# Polje (array) je prosirenje strukture vektora i matrica na 
# dimenzije vece od dvije. 
# Tvorba polja postize se istoimenom funkcijnom array():

po <- array(1:24, c(2, 3, 4))
po

## , , 1
## 
##      [,1] [,2] [,3]
## [1,]    1    3    5
## [2,]    2    4    6
## 
## , , 2
## 
##      [,1] [,2] [,3]
## [1,]    7    9   11
## [2,]    8   10   12
## 
## , , 3
## 
##      [,1] [,2] [,3]
## [1,]   13   15   17
## [2,]   14   16   18
## 
## , , 4
## 
##      [,1] [,2] [,3]
## [1,]   19   21   23
## [2,]   20   22   24

#Dohvacanje elemenata iz ovakve strukture podataka trazi 
# specificiranje svake (pod)dimenzije (ili svih, ako je izostavljena):

po[2, 3, 1]

## [1] 6

po[, 1, 2]

## [1] 7 8

po[, , 4]

##      [,1] [,2] [,3]
## [1,]   19   21   23
## [2,]   20   22   24

po[, 3, ]

##      [,1] [,2] [,3] [,4]
## [1,]    5   11   17   23
## [2,]    6   12   18   24





