
% ovo je m-datoteka sa primjerima s prvog predavanja

% znak "%" oznacava da tekst koji slijedi u toj liniji je komentar (matlab ga ignorira)

help

help elfun     % pomoc o elementarnim funcijama

help ops       % pomoc o operatorima

help format   % pomoc o formatima

help lang       % pomoc o naredbama za upravljanje toka programa

help general  % pomoc o opcim naredbama

help elmat      % elementarne matrice i manipulacija matricama

intro

demo


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%       Matlab kao kalkulator
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


rezultat1=15^2/(3^6-6^3)    % ^ je potenciranje, / je dijeljenje

help ^
help /

% koristenjem ; na kraju redka postizemo da se rezultat tog redka ne
% ispisuje na ekranu, iako se redak izvrsio :

rezultat2=2*log(exp(1))+cos(pi);     % * je mnoenje
rezultat2

help log
help exp
help pi

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%                                        TIPOVI PODATAKA
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%                                                 MATRICE 
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% kod zadavanja matrica koriste se uglate zagrade!

% vektor redak:
v=[1 2 3]    % ili v=[1,2,3];

% vektor stupac
v1=[1; 2; 3]

% matrica 2X3
B=[1 2 3; 4 5 6]          % realna matrica sa dva redka i tri stupca   ( tocka-zarez ; oznacava mjesto prijelaza u sljedeci redak )

% prilikom upisa martice, za prijelaz sa i-tog u (i+1) elementa u redku koristi se ili prazno mjesto ili zarez 

B=[6, 5, 4; 3, 2, 1]

% kompleksan vektor   

v2=[2;4;1]+i*[1;2;3]   % ovdje je i imaginarna jedinica (i^2=-1)

clear v2

i^2

% kompleksna matrica dimenzija 2 x 2
A=[i, 1+0.5*i; -2-i, 4-5*i]           

real(A)       % realan dio matrice A
imag(A)     % imaginaran dio matrice A

% koristenjem ; na kraju redka postizemo da se rezultat tog redka ne
% ispisuje na ekranu, iako se redak izvrsio

C=real(A)+[1, 1; 2, 2];

C


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% BROJEVI - double (s pretvorbama u integer-e (u)int8,16,32,64 )
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


% Double-Precision Floating Point
% MATLAB constructs the double-precision (or double) data type according to IEEE Standard 754 
% for double precision. Any value stored as a double requires 64 bits, formatted as shown below:
% Bits: 63, Usage: Sign (0 = positive, 1 = negative)
% Bits: 62 to 52, Usage: Exponent, biased by 1023  
% Bits: 51 to 0, Usage: Fraction f of the number 1.f	

help double

help single

% govorit cemo vise o formatu zapisa brojeva kad cemo govoriti o numerickim
% problemima 

help int16

int16(pi)

help datatypes


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%                         konstante i varijable
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

pi       % = 3.14156965...

i^2
j^2     % "i" i "j" kao kompleksne jedinice
sqrt(-1)

eps    % to?nost; najmanja udaljenost od 1 do sljede?eg broja

1==1+eps    % daje izlaz 0, to zna?i FALSE (nije istina da je 1 jednako 1+eps)
1==1+0.5*eps     % daje izlaz 1, to zna?i TRUE (za Matlab, 1 je jednako 1+eps/2)

inf   % beskona?no
inf - 10000    % = inf
1/inf               % = 0

NaN   % "Not a number"
help NaN

realmax   % najveci realni broj
realmin     % najmanji realni broj


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%      ZNAKOVI I NIZOVI ZNAKOVA ("stringovi")
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

help strings

S1='Dobar dan, ';
S2='gospodine ';
S3=' Miki';

S=strcat(S1,S2,S3)


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%         MATRICE ... neto vie o matricama...
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% vektor brojeva od 1 do 10 sa korakom 0.2:
niz1=1:0.2:10

% vektor brojeva od 5 do -3 sa korakom -0.2:
niz2=5:-0.5:-3

% ako se korak ne navede, uzima se da je jedank jedinici
niz3=-3:3

niz4=3:-3   % ne radi, tj. kreira praznu matricu (vektor). Sa korakom +1 ne moze se doci iz 3 u -3. trena navesti korak -1
niz4=3:-1:-3 % radi

%%%%%%%%%%%%%%%%%%

% dodavanje elementa na kraj vec opstojeceg vektora
v=[1,2,3];
v(end)              % zadnji element vektora v
v(end+1)=5;
v

%  Kreiranje matrice sa slucajnnim elementima  (vidjeti: help rand, help randn) :

B=10*ones(3)-20*rand(3)

C=rand(3,6)


%  KREIRANJE "POSEBNIH" VRSTA MATRICA :

M1=zeros(2,5)          % nul matrica dimanzija 2 x 5

M2=ones(2,3)           % matrica dimenzija 2 x 3 kojoj su svi elementi jednaki 1

M3=diag([1; 2; 3])     % diagonalna matrica

M4=eye(5)              % jedinicna matrica dimenzija 5 x 5

M5=blkdiag(M2,M3,M4)      % blok dijagonalna matrica


% Kreiranje matrice unosom podmatrica:

A=diag([1;2;3])
B=rand(3,2);

C=[A, B; zeros(2,size(A,2)), ones(2,size(B,2))]

% kreiranje matrica "for, while,..." petljama

%%% PRIMJER 1 %%%
M=[]      % definiramo M kao paznu matricu.
for i=1:5
    M(i,i)=i
end
% napomena: primjer bi radio i da nismo definirali M=[]; ali ako je M vec ranije definirana (u radnom prostoru)
% taba bi modificirali tu vec postojecu matricu . 
% Alternativno, prije "for" petlje u ovom primjeru mogli smo koristiti "clear M"


%%% PRIMJER 2 %%%
M=eye(3)
for i=1:3
    M(3+i,end)=10*i
end
size(M)


%%% PRIMJER 3 %%%
clear M
for i=1:5
    for j=1:5
        if i<j
            M(i,j)=0
        else
            M(i,j)=1
        end
    end
end


% sparse matrice ("rijetke" matrice: velik broj elemenata u matrici jedak je nuli)

N=sparse(10,4,1)
size(N)
N(2,3)
N(10,4)


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%           INDEKSIRANJE, ODABIRANJE ELEMENATA MATRICE
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

v=1:5     % kreira vektor-redak v=[1 2 3 4 5]

v1=v'     % vektor-redak  -->   vektor-stupac ( ' oznacava transponiranje ) 

v(3)     % treci element vektora v
v1(4)    % cetvrti element vektora v    (dakle, kad se radi o vektoru, indeksiramo njegov 
             % element jednako i za vektor stupac i za vektor redak)

             
M=[1 2 3; 4 5 6; 7 8 9]             

[broj_redaka, broj_stupaca]=size(M)
             
M(2,3)   % element matrice M iz drugog retka i treceg stupca

M(6)     % sesti element iz vektora koji se dobije kad se M "razvije" po stupcima

M(:)     % vektor stupac koji sadrzi sve elemenata matrice M "razvijene po stupcima"  

M(2,:)   % drugi redak 
M(:,1)   % prvi stupac

M(2:3,1:2)  % podmatrica matrice M; elementi iz 2. i 3. retka, 1. i 2. stupca 

M([1 3],[1 3])  % podmatrica matrice M; elementi iz 1. i 3. retka, 1. i 3. stupca

M1=M([3 2 1],:)    % matrica M1 dobivena je iz M zamjenom 1. i 3. retka 

M1(:,2)=[]   % brisanje drugog stupca matrice M1

M
M(end,:)=[];     % brisanje zadnjeg redka matrice M
M

M(:,end+1)=[100;101];  % dodavanje vektora stupca nakon trenutno zadnjeg stupca u matrici
M

A=[1 2 3; -1 -4 2; -2 4 1]
A>0      % 1 = istina (true); 0 = neistina (false)
A>1
A(A>0)


%%%%%%%%%%%%%%%%%%%%%%
%        CELIJE
%%%%%%%%%%%%%%%%%%%%%%

% ?elija - cell, polje razlicitih tipova
% definira se viti?astim zagradama { }

Moja_celija={'ovo je string', rand(2,3), [1;2;3], pi}

Moja_celija{1}   % prvi element celije. Pristupanje elementima ?elije isto sa viti?astim zagradama { }

Moja_celija{2}   % drugi element celije

Moja_celija{2}(1,2)  % drugi element ?elije je u ovom slu?aju matrica, dohva?amo element iz 1. redka i 2. stupca

cellplot(Moja_celija)   % ilustrita elemente celije

% ?esta primjena ?elija: spremanje vektora razli?itih duljina (ne mogu se
% jednostavno staviti u matricu):

ocjene={ [3,2,5,4], [4,4,5], [2,2,2,2,2,3]}

length(ocjene) % broj elementana u celiji

% naredba cell

help cell    % cell(dim1,dim2,...,dimN) kreira prazno polje ?elije dimezija dim1 x dim2 x ...  xdimN

Celija_2D=cell(2,2)

Celija_2D{1,1}='ja sam prvi element';
Celija_2D{1,2}=2;
Celija_2D{2,1}='a gdje sam ja?';
Celija_2D{2,2}=eye(3);

Celija_2D


%%%%%%%%%%%%%%%%%%%%%%%
%        STRUKTURE
%%%%%%%%%%%%%%%%%%%%%%%

% struktura - struct, polje razlicitih tipova

help struct

% s = struct('polje1', podaci1, 'polje2', podaci1, ...)
% podaci mogu biti ili skalarne vrijednosti ili ?elije

S1 = struct('imena',{'Marko','Ana'},'visine',[180 160])
S1 
  
S1.imena
S1.visine

%%%%%%%%%

S2 = struct('ime',{'Marko','Ana'},'visina',{180, 160})
S2 
  
S2(1)
S2(2)

%%%%%%%%%

S3 = struct('tip', {'velik','malen'}, 'boja', {'zelena'}, ...
    'x', {3 4});

S3(1)
S3(2)

%%%%%%%%

n=4;
testmat(1).ime='Hilbert';
testmat(1).mat=hilb(n);
testmat(2).ime='Pascal';
testmat(2).mat=pascal(n);

testmat

testmat(1).mat
testmat(2).ime

testmat(2).ime='Pascal i onaj drugi'    % promjena virjednosti podataka
testmat(2).mat(1,1)=NaN   % matrici testmat(2).mat promijenili smo element u prvom redku i prvom stupcu

testmat(2)
testmat(2).mat


% izlazi mnogih algoritama/naredbi su u strukture: spline, solve, diff. i
% optimizacijski rjesavaci

S = solve('x^2*y^2 - 2*x - 1 = 0','x^2 - y^2 - 1 = 0')
S.x
S.y

help solve


%%%%%%%%%%%%%%%%%%%%%%
%             POLINOMI
%%%%%%%%%%%%%%%%%%%%%%

% Polinom se predstavlja vektorom koji sardzi njegove koeficijente.
% Plonom n-tog stupnja ima n+1 koeficijent

% primjer: zadan je polinom P(x)=2*x^3-3*x^2+2
% Vektor koeficijenata koji definira ovaj polinom:

P=[2 -3 0 2];

% kojem polinomu odgovara sljedeci vektor?

P1=[3 0 0 0 1 1];

% odgovor: P1(x)=3*x^5+x+1

% ovakav zapis polinoma konvecija je za naradbe koje rade sa polinomima
% primjer:
% polyval(f,x)  ra?una vrijednost polinoma f u to?ci x

x=-10:0.1:10;
y=polyval([1 0 0 0],x);
plot(x,y)

% ako je x vektor, polyval(f,x) daje vektor [f(x1),f(x2),...] 

x=-3:0.1:3;
y=polyval(P1,x);
plot(x,y,'r--')
grid on





